# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .client_facing_stream_altitude import ClientFacingStreamAltitude
from .client_facing_stream_cadence import ClientFacingStreamCadence
from .client_facing_stream_distance import ClientFacingStreamDistance
from .client_facing_stream_heartrate import ClientFacingStreamHeartrate
from .client_facing_stream_lat import ClientFacingStreamLat
from .client_facing_stream_lng import ClientFacingStreamLng
from .client_facing_stream_power import ClientFacingStreamPower
from .client_facing_stream_resistance import ClientFacingStreamResistance
from .client_facing_stream_velocity_smooth import ClientFacingStreamVelocitySmooth


class ClientFacingStream(pydantic.BaseModel):
    cadence: typing.Optional[ClientFacingStreamCadence] = pydantic.Field(
        description=("RPM for cycling, Steps per minute for running\n")
    )
    time: typing.Optional[typing.List[int]] = pydantic.Field(
        description=("Corresponding time stamp in unix time for datapoint\n")
    )
    altitude: typing.Optional[ClientFacingStreamAltitude] = pydantic.Field(description=("Data points for altitude\n"))
    velocity_smooth: typing.Optional[ClientFacingStreamVelocitySmooth] = pydantic.Field(
        description=("Velocity in m/s\n")
    )
    heartrate: typing.Optional[ClientFacingStreamHeartrate] = pydantic.Field(description=("Heart rate in bpm\n"))
    lat: typing.Optional[ClientFacingStreamLat] = pydantic.Field(description=("Latitude for data point\n"))
    lng: typing.Optional[ClientFacingStreamLng] = pydantic.Field(description=("Longitude for data point\n"))
    distance: typing.Optional[ClientFacingStreamDistance] = pydantic.Field(
        description=("Cumulated distance for exercise\n")
    )
    power: typing.Optional[ClientFacingStreamPower] = pydantic.Field(description=("Power in watts\n"))
    resistance: typing.Optional[ClientFacingStreamResistance] = pydantic.Field(description=("Resistance on bike\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
